var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import featureUtils from "@beisen-cmps/feature-utils";
import BSHelper from '@beisen/helper';
//加载打赏&祝福组件
export function loadFeaturesCmp() {
    // const __talent_features_version = window.__italent_common_cmps__ && window.__italent_common_cmps__.features_version || '';
    // const version = __talent_features_version || '1.3.45'
    // if (!document.getElementById('reward-css')) {
    //     const link = document.createElement('link');
    //     link.type = "text/css";
    //     link.id = 'reward-css'
    //     link.href = `//stnew03.beisen.com/ux/upaas/reward/release/dist/main-${version}.min.css`;
    //     link.rel = "stylesheet";
    //     document.body.appendChild(link)
    // }
    // if (!document.getElementById('reward-js')) {
    //     const script = document.createElement('script');
    //     script.type = "text/javascript"
    //     script.id = 'reward-js'
    //     script.src = `//stnew03.beisen.com/ux/upaas/reward/release/dist/main-${version}.min.js`;
    //     document.body.appendChild(script)
    // }
    // if (!document.getElementById('reward-wrap')) {
    //     const div = document.createElement('div');
    //     div.id = 'reward-wrap'
    //     document.body.appendChild(div)
    // }
}
"";
function checkFeatureEnable() {
    if (!window.Features)
        return;
    var Features = window.Features || {};
    var myFeatureCmp = new Features({
        needMask: false,
        zIndex: 99999999,
        changeLeftMenuShade: true,
        domNode: document.getElementById("reward-wrap") //组件的挂载点
    });
    return myFeatureCmp;
}
export function sendBlessing(toUserId, blessingType) {
    //调用祝福弹层
    featureUtils.call({
        type: "sendBlessings",
        params: {
            needMask: true,
            toUserId: toUserId,
            type: blessingType //  1生日 2入职 3节日
        }
    });
    // const myFeatureCmp = checkFeatureEnable();
    // if (!myFeatureCmp) return;
    // myFeatureCmp.sendBlessings({
    //     needMask: true, //不传的话 就是有
    //     toUserId: toUserId
    // });
}
//收祝福
export function recieveBlssings(toUserId, blessingType) {
    //调用祝福弹层
    featureUtils.call({
        type: "recieveBlssings",
        params: {
            needMask: true,
            toUserId: toUserId,
            type: blessingType //  1生日 2入职 3节日
        }
    });
}
/**
 * 获取当前登录用户信息
 * @return
 * {"Email":"wg1@abc.com","Avatar":"http://st-web.tita.com/titacn/tita/common/images/default_man_small.jpg","Id":100217545,"Name":"wg","IsRoot":false,"Role":3}
 */
export function getUserInfo(url) {
    return getBSGlobal("loginUserInfo");
}
export function getBSGlobal(name) {
    return BSGlobal && BSGlobal[name];
}
// 获取to_user_id
export function getToUserId() {
    var toUserId = getQueryString().to_user_id;
    if (!toUserId) {
        toUserId = getUserInfo().Id;
    }
    return toUserId;
}
export function getQueryString() {
    //获取Url上的参数，以{}返回
    var hash = location.hash;
    var queryObject = {};
    var markIndex = hash.indexOf("?");
    // contain query string in fragments
    if (markIndex > -1) {
        // build query object
        var queryString = hash.slice(markIndex + 1);
        var queryArray = queryString.split("&");
        for (var i = 0; i < queryArray.length; i++) {
            var queryPair = queryArray[i].split("=");
            if (queryPair[0] !== "_k") {
                queryObject[queryPair[0]] = decodeURIComponent(queryPair[1]);
            }
        }
    }
    return queryObject;
}
export function taker(url, method, body) {
    return __awaiter(this, void 0, void 0, function () {
        var settings, response, data, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    settings = {};
                    if (method) {
                        settings.headers = {
                            Accept: "application/json, application/xml, text/play, text/html, *.*",
                            "Content-Type": "application/json; charset=utf-8"
                        };
                        settings.method = method;
                    }
                    if (body)
                        settings.body = JSON.stringify(body);
                    settings.credentials = "same-origin";
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 6]);
                    return [4 /*yield*/, fetch(url, settings)];
                case 2:
                    response = _a.sent();
                    return [4 /*yield*/, response.json()];
                case 3:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 4:
                    e_1 = _a.sent();
                    return [4 /*yield*/, Promise.reject("出错了")];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
export function getApiUrl(url) {
    var uid = getUserInfo().Id;
    var tid = getTenantInfo().Id;
    var apiServer = getBSGlobal("apiPath");
    return apiServer + "/api/v1/" + tid + "/" + uid + "/" + url;
}
export function getTenantInfo(url) {
    return getBSGlobal("tenantInfo");
}
export function encodeURIFn(url) {
    var apiServer = getBSGlobal("apiPath");
    var uid = getBSGlobal("loginUserInfo").Id;
    return (apiServer +
        "/" +
        uid +
        "/ItalentHome#" +
        encodeURIComponent("widget/italent?iTalentFrame=" + encodeURIComponent(url)));
}
export function getCloudApiUrl(url) {
    // const env = getBSGlobal("env");
    // const staticMap = [
    //     "//cloud.italent-inc.cn",
    //     "//cloud.italent.link",
    //     "//cloud.italent.cn"
    // ];
    // switch (env) {
    //     case "develop": //开发
    //         return staticMap[0] + url;
    //     case "Production": //线上
    //         return staticMap[2] + url;
    //     case "Testing":
    //         return staticMap[1] + url;
    //     default:
    //         break;
    // }
    return BSHelper.getHostByType('cloud') + url;
}
export function takerCloud(url, method, body) {
    return __awaiter(this, void 0, void 0, function () {
        var settings, formBody, key, response, data, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    settings = {};
                    if (method) {
                        if (method == "GET") {
                            // const contentType = method == 'GET' || !method ? 'text / plain' : 'application / json'
                            // settings.headers = {
                            //     'Accept': 'application/json, application/xml, text/play, text/html, *.*',
                            //     'Content-Type': `${contentType}; charset=utf-8`
                            // }
                            if (body)
                                settings.body = JSON.stringify(body);
                        }
                        else {
                            if (body) {
                                settings.headers = {
                                    Accept: "application/json, application/xml, text/play, text/html, *.*",
                                    "Content-Type": "application/x-www-form-urlencoded"
                                };
                                formBody = [];
                                for (key in body) {
                                    formBody.push(encodeURIComponent(key) +
                                        "=" +
                                        JSON.stringify(body[key]));
                                }
                                settings.body = formBody.join("&");
                            }
                        }
                        settings.method = method;
                    }
                    settings.credentials = "include";
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 6]);
                    return [4 /*yield*/, fetch(url, settings)];
                case 2:
                    response = _a.sent();
                    return [4 /*yield*/, response.json()];
                case 3:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 4:
                    e_2 = _a.sent();
                    return [4 /*yield*/, Promise.reject("出错了")];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
export function jumpToPersonalHomePage(userId, type) {
    var apiServer = getBSGlobal("apiPath");
    var uid = getBSGlobal("loginUserInfo").Id;
    var url = apiServer + "/" + uid + "/PageBuilderForEdit#/view?to_user_id=" + userId;
    // const isHonor = getBSGlobal('IsHonourRedirect') ? getBSGlobal('IsHonourRedirect') : false
    // console.log(getBSGlobal('IsHonourRedirect'))
    var nowOrNow = type == 1 ? "_blank" : "_parent";
    window.open(encodeURIFn(url), nowOrNow);
}
