var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component } from 'react';
import ReactDom from 'react-dom';
var RenderInBody = /** @class */ (function (_super) {
    __extends(RenderInBody, _super);
    function RenderInBody(p) {
        return _super.call(this, p) || this;
    }
    RenderInBody.prototype.componentDidMount = function () {
        var _a = this.props, top = _a.top, left = _a.left, id = _a.id;
        var _container = document.getElementById(id);
        if (_container !== null) {
            document.body.removeChild(_container);
        }
        this.popup = document.createElement('div');
        document.body.appendChild(this.popup);
        this.popup.style.left = left + 'px';
        this.popup.style.top = top + 'px';
        this.popup.style.zIndex = 999999;
        this.popup.id = id;
        //we can setAttribute of the div only in this way
        this.popup.style.position = 'absolute';
        this.pop = document.getElementById(id);
        this._renderLayer();
    };
    RenderInBody.prototype.componentDidUpdate = function () {
        this._renderLayer();
    };
    RenderInBody.prototype.componentWillUnmount = function () {
        if (this.pop !== null && this.pop.parentElement !== null) {
            document.body.removeChild(this.pop);
        }
    };
    RenderInBody.prototype._renderLayer = function () {
        ReactDom.render(this.props.children, this.pop);
    };
    RenderInBody.prototype.render = function () {
        return null;
    };
    return RenderInBody;
}(Component));
export default RenderInBody;
